; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

loading = True
If Not loading Then
.showChar
	FlushKeys
	HidePointer
	fntDefault2 = LoadFont("Garamond", 20, True)
	SetFont fntDefault2
	
	camDefault2 = CreateCamera()
	If camDefault > 0 Then
		CameraProjMode camDefault, 0
	End If
	CameraProjMode camDefault2, 1
	MoveEntity camDefault2, -30, 0, -65
	CameraFogMode camDefault2, 1
	CameraFogRange camDefault2, 150, 350
	CameraViewport camDefault2, 0, 0, 640, 480
	CameraClsColor camDefault2, 55, 55, 55
	CameraClsMode camDefault2, False, True
	
	lgtAmbient = CreateLight(2, camDefault2)
	LightRange lgtAmbient, 50

	mdlKnight2 = LoadMD2("models\knight\knight.md2")
	EntityTexture mdlKnight2, LoadTexture("models\knight\" + ARM + ".jpg")
	
	LoadW$ = Mid(WEA, Instr(WEA, " ") + 1)
	mdlWeapon2 = LoadMD2("models\knight\" + LoadW + ".md2", mdlKnight2)
	EntityTexture mdlWeapon2, LoadTexture("models\knight\" + WEA + ".jpg")
	AnimateMD2 mdlKnight2, 1, 0.12, 0, 40
	AnimateMD2 mdlWeapon2, 1, 0.12, 0, 40
	TurnEntity mdlKnight2, 0, 145, 0
	imgBackground = LoadImage("images\character.jpg")
	MaskImage imgBackground, 255, 0, 255
	imgCursor2 = LoadImage("images\cursor.bmp")
	MaskImage imgCursor2, 255, 0, 255
	
	MoveEntity mdlKnight2, 0, 10000, 0
	MoveEntity camDefault2, 0, 10000, 0
	
	Gosub ComputeWeight
	
	FlushKeys
	key = 0
	
	While (key <> 27 And key <> 73 And key <> 105) And (Not (button = 1 And (MouseArea(105, 425, 60, 30) Or MouseArea(175, 425, 150, 30))))
	
		WaitTimer frmRate
	
		DrawImage imgBackground, 0, 0
		
		Color 255, 255, 255
		ShadowText(50, 50, "Name: " + name, False, False)
		ShadowText(50, 65, "Age: " + age, False, False)
	
		Color 0, 60, 215
		ShadowText(50, 95, "Base Stats:", False, False)
		Color 255, 255, 255
		ShadowText(60, 115, "Power: " + POW, False, False)
		ShadowText(60, 130, "Resistance: " + RES, False, False)
		ShadowText(60, 145, "Coordination: " + COO, False, False)
		ShadowText(60, 160, "Speed: " + SPE, False, False)
		ShadowText(60, 175, "Mind: " + MIN, False, False)
		ShadowText(60, 190, "Awareness: " + AWA, False, False)
	
		Color 0, 60, 215
		ShadowText(200, 95, "Derived Stats:", False, False)
		Color 255, 255, 255
		ShadowText(210, 115, "Move: " + Int(MOV) + "/" + MOVT, False, False)
		ShadowText(210, 130, "Morale: " + MOR + "/" + MORT, False, False)
		ShadowText(210, 145, "Health: " + HEA + "/" + HEAT, False, False)
		ShadowText(210, 160, "Carrying: " + CAR + "/" + CART, False, False)
	
		Color 0, 60, 215
		ShadowText(200, 190, "Skills:", False, False)
		Color 255, 255, 255
		ShadowText(210, 210, "Strength: " + ST, False, False)
		ShadowText(210, 225, "Dexterity: " + DE, False, False)
		ShadowText(210, 240, "Mental: " + ME, False, False)
	
		Color 0, 60, 215
		ShadowText(50, 220, "Possessions:", False, False)
		Color 240, 240, 0
		ShadowText(60, 240, "Golds: " + GOL, False, False)
		Color 255, 255, 255
		ShadowText(60, 255, "Potions: " + POT, False, False)
		ShadowText(60, 270, "Weapon: " + WEA, False, False)
		ShadowText(60, 285, "Armor: " + ARM, False, False)
	
		Color 0, 60, 215
		ShadowText(50, 315, "Volatile Stats:", False, False)
		If ALI < -100 Then
			Color 255, 0, 0
		ElseIf ALI > 100 Then
			Color 0, 255, 0
		Else
			Color 255, 255, 255
		End If
		ShadowText(60, 330, "Alignment: " + ALI, False, False)
		Color 200, 0, 0
		ShadowText(60, 345, "Damages: " + DAM, False, False)
		Color 0, 200, 0
		ShadowText(60, 360, "Absorption: " + AB, False, False)
	
		Color 255, 255, 255
		ShadowText(135, 440, "OK", True, True)
		ShadowText(250, 440, "Inventory", True, True)
		
		key = GetKey()
		button = GetMouse()

		TurnEntity mdlKnight2, 0, 0.5, 0
		UpdateWorld
		RenderWorld

		DrawImage imgCursor2, MouseX(), MouseY()
	
		Flip
		
	Wend
	PlaySound sndClick
	
	FreeEntity mdlWeapon2
	FreeEntity mdlKnight2
	FreeEntity lgtAmbient
	FreeEntity camDefault2
	FreeImage imgBackground
	If camDefault > 0 Then
		CameraProjMode camDefault, 1
	End If

	
	If key = 73 Or key = 105 Or (button = 1 And MouseArea(175, 425, 150, 30)) Then
		imgInv = LoadImage("images\inventory.jpg")
		imgInvBtn = LoadImage("images\inventorybtn.jpg")
		MaskImage imgInv, 255, 0, 255
		MaskImage imgInvBtn, 255, 0, 255
		fntDefault2 = LoadFont("Garamond", 14, True)
		SetFont fntDefault2
		firstItem = 0
		FinishedInv = False

		While Not FinishedInv
		
			WaitTimer frmRate

			DrawImage imgInv, 0, 0
			
			SW = 25
			IW = 110
			VW = 40
			WW = 50
			CW = IW + VW + WW
			RW = 12
			RS = 20
			TR = (420 - RS) / RW

			Color 255, 255, 255
			ShadowText(SW, 5, "Item", False, False)
			ShadowText(SW + IW, 5, "Value", False, False)
			ShadowText(SW + IW + VW, 5, "Weight", False, False)

			row = 0
			col = 0
			Color 50, 50, 255
			count = 0
			Nxt = False
			Prv = False
			For items.Valuable = Each Valuable
				If count >= firstItem Then
					ShadowText(SW + col * CW, RS + row * RW, GetName(valuables(items\id)), False, False)
					ShadowText(SW + IW + 5 + col * CW, RS + row * RW, Int(items\value), False, False)
					ShadowText(SW + IW + VW + 5 + col * CW, RS + row * RW, GetWeight(valuables(items\id)), False, False)
					row = row + 1
					If row > TR Then
						row = 0
						col = col + 1
						If col < 3
							Color 255, 255, 255
							ShadowText(SW + col * CW, 5, "Item", False, False)
							ShadowText(SW + IW + col * CW, 5, "Value", False, False)
							ShadowText(SW + IW + VW + col * CW, 5, "Weight", False, False)
							Color 50, 50, 255
						Else
							Nxt = True
							Exit
						End If
					End If
				End If
				count = count + 1
			Next
			If firstItem > 0 Then
				Prv = True
			End If
			
			Color 255, 255, 255
			If Nxt And Prv Then
				DrawImage imgInvBtn, 85, 435
				ShadowText(160, 455, "Previous", True, True)
				DrawImage imgInvBtn, 245, 435
				ShadowText(320, 455, "OK", True, True)
				DrawImage imgInvBtn, 405, 435
				ShadowText(480, 455, "Next", True, True)
			ElseIf Nxt Then
				DrawImage imgInvBtn, 245, 435
				ShadowText(320, 455, "OK", True, True)
				DrawImage imgInvBtn, 405, 435
				ShadowText(480, 455, "Next", True, True)
			ElseIf Prv Then
				DrawImage imgInvBtn, 85, 435
				ShadowText(160, 455, "Previous", True, True)
				DrawImage imgInvBtn, 245, 435
				ShadowText(320, 455, "OK", True, True)
			Else
				DrawImage imgInvBtn, 245, 435
				ShadowText(320, 455, "OK", True, True)
			End If
			
			key = GetKey()
			button = GetMouse()
			If Nxt And ((key = 78 Or key = 110) Or (button = 1 And MouseArea(405, 435, 150, 40))) Then
				firstItem = firstItem + 102
				PlaySound sndClick
			End If
			If Prv And ((key = 80 Or key = 112) Or (button = 1 And MouseArea(85, 435, 150, 40))) Then
				firstItem = firstItem - 102
				PlaySound sndClick
			End If
			If key = 27 Or (button = 1 And MouseArea(245, 435, 150, 40))
				FinishedInv = True
			End If

			DrawImage imgCursor2, MouseX(), MouseY()
			
			Flip
			
		Wend
		PlaySound sndClick
		FreeImage imgInv
		FreeImage imgInvBtn
	End If
	FreeFont fntDefault2
	FreeImage imgCursor2
	
	key = 0
	FlushKeys
Return

.ComputeWeight
	WMt$ = Left(WEA, Instr(WEA, " ") - 1)
	AMt$ = Left(ARM, Instr(ARM, " ") - 1)
	Select WMt
		Case "Iron"
			WWt = 4
		Case "Steel"
			WWt = 2
		Case "Mythril"
			WWt = 3
		Case "Dwarven"
			WWt = 5
		Case "Emerald"
			WWt = 7
		Case "Adamantium"
			WWt = 6
		Case "Daemonic"
			WWt = 10
	End Select
	Select AMt
		Case "Iron"
			AWt = 4
		Case "Steel"
			AWt = 2
		Case "Mythril"
			AWt = 3
		Case "Dwarven"
			AWt = 5
		Case "Emerald"
			AWt = 7
		Case "Adamantium"
			AWt = 6
		Case "Daemonic"
			AWt = 10
	End Select
	Select LoadW
		Case "Axe"
			WWt2 = 4
		Case "Mace"
			WWt2 = 3
		Case "Longsword"
			WWt2 = 5
		Case "Battle Axe"
			WWt2 = 9
		Case "Broad Sword"
			WWt2 = 8
		Case "Flail"
			WWt2 = 14
	End Select

	CAR = POT / 15 + WWt + WWt2 + 5 * AWt + GOL / 500
	
	For items.Valuable = Each valuable
		CAR = CAR + getWeight(valuables(items\id))
	Next
Return

End If
loading = False