; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

If zones(zx, zy)\texture < 10 Then
	zonT$ = "0"
Else
	zonT$ = ""
End If
zonT = zonT + zones(zx, zy)\texture
texZone = LoadTexture("textures\terrain_" + zonT + ".jpg")
ScaleTexture texZone, 100, 100

AmbientLight 155, 155, 155

sndDie = LoadSound("sounds\die.wav")

mdlKnight = LoadMD2("models\knight\knight.md2")
EntityTexture mdlKnight, LoadTexture("models\knight\" + ARM + ".jpg")
AnimateMD2 mdlKnight, 3, 0.12, 178, 183

camDefault = CreateCamera()
CameraProjMode camDefault, 1
MoveEntity camDefault, 0, -15, 50
TurnEntity camDefault, 0, 180, 0

lgtDefault = CreateLight(3)
LightRange lgtDefault, 640
MoveEntity lgtDefault, 0, 60, -15
LightConeAngles lgtDefault, 30, 90
PointEntity lgtDefault, mdlKnight

plnGround = CreatePlane()
MoveEntity plnGround, 0, -24, 0
EntityAlpha plnGround, 0.7
mirGround = CreateMirror()
MoveEntity mirGround, 0, -25, 0
EntityTexture plnGround, texZone

PlaySound sndDie

While MD2Animating(mdlKnight)

	WaitTimer frmRate

	MoveEntity camDefault, 5, 2, 0
	PointEntity camDefault, mdlKnight

	UpdateWorld
	RenderWorld

	L_DisplayMessages(logMsg, 253, 340, 226, 119)

	Flip

Wend

For Counter = 0 To 5

	WaitTimer frmRate

	MoveEntity camDefault, 5, 2, 0
	PointEntity camDefault, mdlKnight

	UpdateWorld
	RenderWorld

	L_DisplayMessages(logMsg, 253, 340, 226, 119)

	Flip

Next

For Counter = 0 To 20

	WaitTimer frmRate

	UpdateWorld
	RenderWorld

	L_DisplayMessages(logMsg, 253, 340, 226, 119)

	Flip

Next

RotateEntity camDefault, 90, 0, 180
PositionEntity camDefault, 1, -13, -40

UpdateWorld
RenderWorld

L_DisplayMessages(logMsg, 253, 340, 226, 119)


fntDefault = LoadFont("Times New Roman", 78, True)
SetFont fntDefault
Color 0, 0, 0
For Count = 315 To 325
	For Counter = 235 To 245
		Text(Count, Counter, "You died!", True, True)
	Next
Next
Color 255, 0, 0
Text(320, 240, "You died!", True, True)

Flip

FlushKeys
While GetKey() = 0
Wend

FreeSound sndDie
FreeEntity mdlKnight
FreeEntity camDefault
FreeEntity plnGround
FreeEntity mirGround
FreeTexture texZone