; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

Function GenerateStoneHenge()
	rad = 400
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 60
		LowNPC = LowNPC + 3
		HighNPC = HighNPC + 5
		props.Prop = New Prop
		props\ModelPath = "models\henge\henge" + Rand(1,3) + ".3ds"
		props\TexPath = "models\henge\he3.bmp"
		props\Radius = 500
		props\X = x
		props\Y = y
		props\H = 60
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\WS = Rnd(3, 4)
		props\HS = Rnd(3, 4)
		props\ZX = zx
		props\ZY = zy
	End If
End Function

Function GenerateTreasureChest()
	rad = 100
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		room = room - 5
		props.Prop = New Prop
		props\ModelPath = "models\treasures\chest.3ds"
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = 12
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = 0.3
		props\WS = 0.3
		props\ZX = zx
		props\ZY = zy
		props\Treasure = True
		props\GOL = Rand(1, 3)
		If props\GOL = 1 Then
			props\GOL = 0
		Else
			props\GOL = Rand(15, 70)
		End If
	End If

End Function

Function GenerateBarrel()
	rad = 100
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		room = room - 3
		props.Prop = New Prop
		props\ModelPath = "models\treasures\barrel.3ds"
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = 0
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = 0.25
		props\WS = 0.3
		props\ZX = zx
		props\ZY = zy
		props\Treasure = True
		props\GOL = Rand(1, 3)
		If props\GOL = 1 Then
			props\GOL = Rand(2, 15)
		Else
			props\GOL = 0
		End If
	End If

End Function

Function GenerateGenStore()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 1
		HighNPC = HighNPC + 2
		props.Prop = New Prop
		props\ModelPath = "models\shops\genstore.3ds"
		props\TexPath = "models\shops\genstore.jpg"
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 75
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
		shops.Shop = New Shop
		shops\items = "*"
		count = 1
		For shops.Shop = Each shop
			If shops\items = "*" Then
				props\shop = count
				shops\items = ""
				Exit
			End If
			count = count + 1
		Next
		shops\gol = Rand(500, 800)
		shops\pot = Rand(5, 20)
		shopItems = Rand(9, 15)
		shopWeapons = Rand(0, 2)
		shopArmors = Rand(0, 1)
		For count = 1 To shopItems
			newItem$ = Rand(0, maxItems)
			If Len(newItem) < 2 Then
				newItem = "0" + newItem
			End If
			If Len(newItem) < 3 Then
				newItem = "0" + newItem
			End If
			itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
			If Len(itemValue) < 2 Then
				itemValue = "0" + itemValue
			End If
			If Len(itemValue) < 3 Then
				itemValue = "0" + itemValue
			End If
			shops\items = shops\items + newItem + itemValue
		Next
		For count = 1 To shopWeapons
			newWeapon = Rand(1, 6)
			Select newWeapon
				Case 1
					shops\weapons = shops\weapons + "02"
				Case 2
					shops\weapons = shops\weapons + "03"
				Case 3
					shops\weapons = shops\weapons + "07"
				Case 4
					shops\weapons = shops\weapons + "11"
				Case 5
					shops\weapons = shops\weapons + "14"
				Case 6
					shops\weapons = shops\weapons + "20"
			End Select
			newWeapon = Rand(2, 8 - newWeapon)
			If newWeapon < 1 Then
				newWeapon = 1
			End If
			Select newWeapon
				Case 1
					shops\weapons = shops\weapons + "01"
				Case 2
					shops\weapons = shops\weapons + "04"
				Case 3
					shops\weapons = shops\weapons + "08"
				Case 4
					shops\weapons = shops\weapons + "13"
				Case 5
					shops\weapons = shops\weapons + "19"
				Case 6
					shops\weapons = shops\weapons + "24"
				Case 7
					shops\weapons = shops\weapons + "30"
			End Select
		Next		
		For count = 1 To shopArmors
			newArmor = Rand(1, 4)
			Select newArmor
				Case 1
					shops\armors = shops\armors + "01"
				Case 2
					shops\armors = shops\armors + "04"
				Case 3
					shops\armors = shops\armors + "08"
				Case 4
					shops\armors = shops\armors + "13"
				Case 5
					shops\armors = shops\armors + "19"
				Case 6
					shops\armors = shops\armors + "24"
				Case 7
					shops\armors = shops\armors + "30"
			End Select
		Next		
	End If

End Function

Function GenerateBlackSmith()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 1
		HighNPC = HighNPC + 3
		props.Prop = New Prop
		props\ModelPath = "models\shops\blacksmith.3ds"
		props\TexPath = "models\shops\blacksmith.jpg"
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 75
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
		shops.Shop = New Shop
		shops\items = "*"
		count = 1
		For shops.Shop = Each shop
			If shops\items = "*" Then
				props\shop = count
				shops\items = ""
				Exit
			End If
			count = count + 1
		Next
		shops\gol = Rand(700, 1300)
		shops\pot = Rand(5, 20)
		shopItems = Rand(0, 4)
		shopWeapons = Rand(5, 8)
		shopArmors = Rand(3, 6)
		For count = 1 To shopItems
			newItem$ = Rand(0, maxItems)
			If Len(newItem) < 2 Then
				newItem = "0" + newItem
			End If
			If Len(newItem) < 3 Then
				newItem = "0" + newItem
			End If
			itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
			If Len(itemValue) < 2 Then
				itemValue = "0" + itemValue
			End If
			If Len(itemValue) < 3 Then
				itemValue = "0" + itemValue
			End If
			shops\items = shops\items + newItem + itemValue
		Next
		For count = 1 To shopWeapons
			newWeapon = Rand(1, 6)
			Select newWeapon
				Case 1
					shops\weapons = shops\weapons + "02"
				Case 2
					shops\weapons = shops\weapons + "03"
				Case 3
					shops\weapons = shops\weapons + "07"
				Case 4
					shops\weapons = shops\weapons + "11"
				Case 5
					shops\weapons = shops\weapons + "14"
				Case 6
					shops\weapons = shops\weapons + "20"
			End Select
			newWeapon = Rand(1, 7)
			Select newWeapon
				Case 1
					shops\weapons = shops\weapons + "01"
				Case 2
					shops\weapons = shops\weapons + "04"
				Case 3
					shops\weapons = shops\weapons + "08"
				Case 4
					shops\weapons = shops\weapons + "13"
				Case 5
					shops\weapons = shops\weapons + "19"
				Case 6
					shops\weapons = shops\weapons + "24"
				Case 7
					shops\weapons = shops\weapons + "30"
			End Select
		Next
		For count = 1 To shopArmors
			newArmor = Rand(1, 7)
			Select newArmor
				Case 1
					shops\armors = shops\armors + "01"
				Case 2
					shops\armors = shops\armors + "04"
				Case 3
					shops\armors = shops\armors + "08"
				Case 4
					shops\armors = shops\armors + "13"
				Case 5
					shops\armors = shops\armors + "19"
				Case 6
					shops\armors = shops\armors + "24"
				Case 7
					shops\armors = shops\armors + "30"
			End Select
		Next		
	End If

End Function

Function GenerateTavern()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 2
		HighNPC = HighNPC + 5
		props.Prop = New Prop
		props\ModelPath = "models\town\bar.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 85
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateBlackSmith2()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 1
		HighNPC = HighNPC + 3
		props.Prop = New Prop
		props\ModelPath = "models\town\blacksmiths.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 10
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateChurch()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 1
		HighNPC = HighNPC + 4
		props.Prop = New Prop
		props\ModelPath = "models\town\church.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 210
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(3, 4)
		props\WS = Rnd(3, 4)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateInn()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 2
		HighNPC = HighNPC + 6
		props.Prop = New Prop
		props\ModelPath = "models\town\inn.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 10
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateMage()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 1
		HighNPC = HighNPC + 2
		props.Prop = New Prop
		props\ModelPath = "models\town\potions.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 0
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(5, 6)
		props\WS = Rnd(5, 6)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateTower()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 0
		HighNPC = HighNPC + 1
		props.Prop = New Prop
		props\ModelPath = "models\town\tower.3ds"
		props\TexPath = ""
		props\Radius = 350
		props\X = x
		props\Y = y
		props\H = 85
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\HS = Rnd(4, 4.5)
		props\WS = Rnd(2, 2.5)
		props\ZX = zx
		props\ZY = zy
	End If

End Function

Function GenerateHouses()
	rad = 250
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		LowNPC = LowNPC + 0
		HighNPC = HighNPC + 2
		props.Prop = New Prop
		h = Rand(1, 3)
		If h = 1 Then
			props\ModelPath = "models\house\house.3ds"
			props\TexPath = "models\house\house.jpg"
			props\Radius = 350
			props\X = x
			props\Y = y
			props\H = 10
			props\Angle = Rand(0, 360)
			props\Pitch = -90
			props\HS = Rnd(5, 6)
			props\WS = Rnd(5, 6)
			props\ZX = zx
			props\ZY = zy
		Else
			If h = 2 Then
				props\ModelPath = "models\town\townhouse.3ds"
			Else
				props\ModelPath = "models\town\townhouse2.3ds"
			End If
			props\TexPath = ""
			props\Radius = 350
			props\X = x
			props\Y = y
			props\H = 0
			props\Angle = Rand(0, 360)
			props\Pitch = 0
			props\HS = Rnd(5, 6)
			props\WS = Rnd(5, 6)
			props\ZX = zx
			props\ZY = zy
		End If			
	End If

End Function

Function GenerateTree()
	rad = 75
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 3
		props.Prop = New Prop
		props\ModelPath = "models\trees\tree" + Rand(1,8) + ".b3d"
		props\TexPath = ""
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = 0
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\WS = Rnd(0.3, 0.45)
		props\HS = Rnd(0.35, 0.5)
		props\ZX = zx
		props\ZY = zy
	End If
	
End Function

Function GeneratePopulatedArea()
	GenerateWagon()
	GenerateBarrel()
	Room = Room - 35
	LowNPC = LowNPC + 5
	HighNPC = HighNPC + 8
End Function

Function GenerateVillage()
	GenerateTower()
	GenerateTavern()
	GenerateWagon()
	GenerateWagon()
	GenerateGenStore()
	GenerateHouses()
	GenerateBlackSmith()
	GenerateHouses()
	GenerateWagon()
	GenerateHouses()
	GenerateInn()
	GenerateChurch()
	GenerateMage()
	GenerateBlackSmith2()
	GenerateBarrel()
	GenerateBarrel()
	GenerateBarrel()
	GenerateBarrel()
	GenerateBarrel()
End Function

Function GenerateNothing()
	Room = Room - 25
	LowNPC = LowNPC - 1
	HighNPC = HighNPC - 3
End Function

Function GenerateNPCs()
	Room = Room - 10
	LowNPC = LowNPC + 1
	HighNPC = HighNPC + 3

End Function

Function GenerateWood()
	For i = 1 To 10
		GenerateTree()
	Next
End Function

Function GenerateForest()
	For i = 1 To 20
		GenerateTree()
	Next
End Function

Function GenerateQuest(start = False)
	rad = 75
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 10
		props.Prop = New Prop
		props\ModelPath = "models\obelisk\obelisk.b3d"
		props\TexPath = "models\obelisk\obelisk.bmp"
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = -1
		props\Angle = Rand(0, 360)
		props\Pitch = 0
		props\WS = Rnd(2, 2.5)
		props\HS = Rnd(2, 3)
		props\ZX = zx
		props\ZY = zy
		; QUEST STUFF
		ID = 1
		For Quests.Quest = Each Quest
			If ID = Quests\ID Then
				ID = ID + 1
			End If
		Next
		quests.Quest = New Quest
		Quests\ID = ID
		props\Quest = ID
		Objective$ = ""
		While Objective$ = ""
			QType = Rand(1, 8) ; 1 = Retrieve, 2 = Kill, 3 = Convince, 4 = pickpocket, 5 = kill race, 6 = bring golds, 7 = kill group, 8 = get respect group
			If QType = 1 Then
				Objective$ = GetName(valuables(Rand(0, maxItems)))
			ElseIf QType = 2 Or QType = 3 Then
				If Not Start Then
					npccount = 0
					For NPCs.NPC = Each NPC
						npccount = npccount + 1
					Next
					i = Rand(1, npcCount)
					j = 0
					For NPCs.NPC = Each NPC
						j = j + 1
						If j = i Then
							If Not NPCs\Dead Then
								Objective$ = NPCs\Name$
							End If
							Exit
						End If
					Next
				End If
			ElseIf QType = 4 Then
				Objective$ = Rand(50, 3 * DE)
			ElseIf QType = 5 Then
				If Not Start Then
					Objective$ = Mid(groupRaces(Groups(Rand(1, groupcount))\RaceID), 11)
				End If
			ElseIf QTYpe = 6 Then
				Objective$ = Rand(GOL * 0.5, GOL * 0.75)
			ElseIf Qtype = 7 Or QType = 8 Then
				If Not Start Then
					Objective$ = Groups(Rand(1, groupcount))\name$
				End If
			End If
		Wend
		Quests\Typ = QType
		Quests\Name$ = Objective$
	End If
	
End Function

Function GenerateRock()
	rad = 75
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 1
		props.Prop = New Prop
		props\ModelPath = "models\rocks\rock" + Rand(1,3) + ".3ds"
		props\TexPath = ""
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = 3
		props\Angle = Rand(0, 360)
		props\Pitch = 90
		props\WS = Rnd(1, 3)
		props\HS = Rnd(1, 3)
		props\ZX = zx
		props\ZY = zy
	End If
	
End Function

Function GenerateWagon()
	rad = 100
	loops = 0
	Repeat
		x = Rand(rad * 2, 2500 - rad * 2)
		y = Rand(rad * 2, 2500 - rad * 2)
		loops = loops + 1
	Until (Not PropInWay(x, y, rad, zx, zy)) Or loops >= 100
	If loops < 100
		Room = Room - 7
		props.Prop = New Prop
		Select Rand(1, 4)
			Case 2
				w$ = "_hay"
			Case 3
				w$ = "_broken"
			Case 4
				w$ = "_broken_hay"
		End Select
		props\ModelPath = "models\wagons\wagon" + w$ + ".3ds"
		props\TexPath = ""
		props\Radius = 0
		props\X = x
		props\Y = y
		props\H = 0
		props\Angle = Rand(0, 360)
		props\Pitch = -90
		props\WS = Rnd(1.2, 1.7)
		props\HS = Rnd(1.2, 1.7)
		props\ZX = zx
		props\ZY = zy
	End If
	
End Function

Function GenerateNPC(i)
	Select Rand(1, 7)
		Case 1
			Gen = GenNPC("Bubba the Big", "01", "01", 2.0, 1.7, 1.0, 50)
		Case 2
			Gen = GenNPC("Rhamses ]|[", "02", "01", 1.0, 1.4, 2.0, -500)
		Case 3
			Gen = GenNPC("Chaos Jr.", "05", "99", 1.5, 1.75, 3.0, -1000)
		Case 4
			Gen = GenNPC("American Werewolf", "03", "02", 1.3, 1.4, 1.2, -600)
		Case 5
			Gen = GenNPC("The Tooth Fairy", "04", "01", 1.0, 1.0, 1.0, 600)
		Case 6
			Gen = GenNPC("Sheila the Pixie", "04", "01", 0.4, 0.3, 2.5, 300)
		Case 7
			Gen = GenNPC("King Arthur",  "12", "01", 1.2, 1,   3.0, 400)
			Gen = GenNPC("Sir Lancelot", "12", "01", 1.4, 0.8, 2.0, 400)
			Gen = GenNPC("Percival",     "12", "01", 1.1, 1.4, 2.5, 400)
			Room = Room - 10
	End Select
	If Not Gen And i < 10 Then
		GenerateNPC(i + 1)
	End If
End Function

Function GenNPC(name$, race$, tex$, h#, w#, cons#, ali)
	For Grps.Group = Each Group
		If Grps\modelnumber = race Then
			Found = True
			Exit
		End If
		Grp = Grp + 1
	Next
	If Found Then
		Room = Room - 5
		NPCs.NPC = New NPC
		NPCs\zx = zx
		NPCs\zy = zy
		NPCs\group = Grp
		NPCs\lastFaction = groups(NPCs\group)\faction
		NPCs\race = Mid(groupRaces(groups(NPCs\group)\raceID), 11)
		NPCs\number = race
		NPCs\texnumber = tex
		Repeat
			NPCs\X = Rand(60, 2500)
			NPCs\Y = Rand(60, 2500)
		Until (Not PropInWay(NPCs\X, NPCs\Y, 15, zx, zy))
		NPCs\name = name

		StatsValue# = (HEAT + MOVT + MORT + ST + DE + ME + DAM + AB) * cons#
		BStatsValue = StatsValue * Rnd(0.67, 0.73)
		RStatsValue = StatsValue * Rnd(0.28, 0.32)
		While BStatsValue > 0
			NPCs\HEA = NPCs\HEA + 10
			NPCs\MOV = NPCs\MOV + 10
			NPCs\MOR = NPCs\MOR + 10
			NPCs\ST = NPCs\ST + 5
			NPCs\DE = NPCs\DE + 5
			NPCs\ME = NPCs\ME + 5
			NPCs\DAM = NPCs\DAM + 3
			NPCs\AB = NPCs\AB + 1
			BStatsValue = BStatsValue - 50
		Wend
		While RStatsValue > 0
			StatChange = Rand(1, 6)
			Select StatChange
				Case 1
					NPCs\HEA = NPCs\HEA + 1
					RStatsValue = RStatsValue - 1
				Case 2
					NPCs\MOR = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 3
					NPCs\MOV = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 4
					NPCs\ST = NPCs\ST + 1
					RStatsValue = RStatsValue - 1
				Case 5
					NPCs\DE = NPCs\DE + 1
					RStatsValue = RStatsValue - 1
				Case 6
					NPCs\ME = NPCs\ME + 1
					RStatsValue = RStatsValue - 1
			End Select
		Wend

		NPCs\ALI = ali
		NPCs\GOL = Rand(15, 50) * cons# * cons#
		cd# = cons#
		If outer = 1 Then
			mp# = cons#
			NPCs\HEA = NPCs\HEA / cons#
			NPCs\MOV = NPCs\MOV / cons#
			NPCs\MOR = NPCs\MOV / cons#
			NPCs\ST = NPCs\ST / cons#
			NPCs\ME = NPCs\ME / cons#
			NPCs\DE = NPCs\DE / cons#
			NPCs\DAM = NPCs\DAM / cons#
			NPCs\AB = NPCs\AB / cons#
			NPCs\GOL = NPCs\GOL / cons#
			NPCs\group = oldGroup
			mp# = (mp + cons#) / 2
			NPCs\HEA = NPCs\HEA * mp
			NPCs\MOV = NPCs\MOV * mp
			NPCs\MOR = NPCs\MOV * mp
			NPCs\ST = NPCs\ST * mp
			NPCs\ME = NPCs\ME * mp
			NPCs\DE = NPCs\DE * mp
			NPCs\DAM = NPCs\DAM * mp
			NPCs\AB = NPCs\AB * mp
			NPCs\GOL = NPCs\GOL * mp
			NPCs\ALI = (NPCs\ALI + groups(NPCs\group)\ALI) / 2
			cd = (cd * 2/3 + Float(cons#) * 1/3)
		End If
		NPCs\ALI = NPCs\ALI + Rand(0, 100) - 50
		NPCs\REA = CompREA(ALI, NPCs\ALI)
		NPCs\HEAT = NPCs\HEA
		NPCs\MOVT = NPCs\MOV
		NPCs\MORT = NPCs\MOR

; SCALE FROM CONSIDER
		NPCs\W = w#
		NPCs\H = h#
		
; ITEMS GENERATION
		numItems = Rand(2, 8) * cons#
		NPCs\items = ""
		For count = 1 To numItems
			newItem$ = Rand(0, maxItems)
			If Len(newItem) < 2 Then
				newItem = "0" + newItem
			End If
			If Len(newItem) < 3 Then
				newItem = "0" + newItem
			End If
			itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
			If Len(itemValue) < 2 Then
				itemValue = "0" + itemValue
			End If
			If Len(itemValue) < 3 Then
				itemValue = "0" + itemValue
			End If
			NPCs\items = NPCs\items + newItem + itemValue
		Next				
	End If
	Return Found
End Function
		