; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; LOAD MODULE
If LoadingLoad1 Then
.Load

imgPointer = LoadImage("images\cursor.bmp")
imgSaveLoad = LoadImage("images\saveload.jpg")
imgDisSL1 = LoadImage("images\disableSL1.bmp")
imgDisSL2 = LoadImage("images\disableSL1.bmp")
imgSlot = LoadImage("images\slot.bmp")
MaskImage imgPointer, 255, 0, 255
MaskImage imgSaveLoad, 255, 0, 255
MaskImage imgDisSL1, 255, 0, 255
MaskImage imgDisSL2, 255, 0, 255
MaskImage imgSlot, 255, 0, 255
fntSaveLoad = LoadFont("Times New Roman", 14, True)
SetFont fntSaveLoad

SlotSelected = False
Slot = 0
OKPressed = False
CancelPressed = False

countEmpty = 0
For Count = 0 To 9
	imgShots(Count) = LoadImage("saves\slot" + Count + "\screenshot.bmp")
	MaskImage imgShots(Count), 255, 0, 255
	filSlot = ReadFile("saves\slot" + Count + "\character.dat")
		SlotName(Count) = ReadLine(filSlot)
		If Left(SlotName(0), 1) <> "*" And Count = 0 Then
			SlotSelected = True
		End If
		If Left(SlotName(Count), 1) = "*" Then
			countEmpty = countEmpty + 1
			Empty(Count) = True
			SlotName(Count) = Mid(SlotName(Count), 2)
		Else
			Info(Count, 0) = ReadLine(filSlot)
			VNs(Count) = ReadLine(filSlot)
			TempData$ = ReadLine(filSlot)
			TempData = ReadInt(filSlot)
			TDminute# = ReadFloat(filSlot)
			TDhour = ReadInt(filSlot)
			TDday = ReadInt(filSlot)
			TDyear = ReadInt(filSlot)
			minu$ = Int(TDminute)
			If Int(minu) < 10 Then
				minu = "0" + minu
			End If
			If minu = "60" Then
				minu = "00"
			End If
			hr$ = Int(TDhour)
			If hr = "24" Then
				hr = "0"
			End If
			dayS$ = Int(TDday)
			If dayS = "366" Then
				dayS = "1"
			End If
			Info(Count, 1) = hr+":"+minu+" on day "+dayS+" of the year "+TDyear
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 2) = "POW: " + ReadInt(filSlot)
			Info(Count, 8) = "RES: " + ReadInt(filSlot)
			Info(Count, 3) = "COO: " + ReadInt(filSlot)
			Info(Count, 9) = "SPE: " + ReadInt(filSlot)
			Info(Count, 4) = "MIN: " + ReadInt(filSlot)
			Info(Count, 10) = "AWA: " + ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 5) = "Strength: " + ReadInt(filSlot)
			TempData = ReadFloat(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 6) = "Dexterity: " + ReadInt(filSlot)
			TempData = ReadFloat(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 7) = "Mental: " + ReadInt(filSlot)
		End If
	CloseFile filSlot
Next

Repeat

	WaitTimer frmRate
	
	DrawImage imgSaveLoad, 0, 0

	DrawImage imgShots(Slot), 365, 35
	
	For Count = 0 To 9
		If Empty(Count) Then
			DrawImage imgDisSL1, 35, 35 + 41 * Count
		End If
		Color 255, 255, 255
		OutlineText(45, 53 + 41 * Count, SlotName(Count), False, True)
	Next
	
	If SlotSelected Then
		DrawImage imgSlot, 10, 35 + 41 * Slot
		For Count = 0 To 7
			OutlineText(375, 230 + Count * 15, Info(Slot, Count), False, False)
		Next
		For Count = 8 To 10
			OutlineText(475, 230 + (Count - 6) * 15, Info(Slot, Count), False, False)
		Next
		If NotCompatible(VNs(Slot), VersionNumber$) Then
			Color 255, 0, 0
		End If
		OutlineText(475, 335, "v" + VNs(Slot), False, False)
	End If
	
	If (Not SlotSelected) Or CountEmpty = 10 Then
		DrawImage imgDisSL2, 365, 404
	End If
	
	DrawImage imgPointer, MouseX(), MouseY()
	
	Flip
	
	button = GetMouse()
	key = GetKey()
	
	If button = 1 Then
		If MouseArea(35, 35, 295, 409)
			newSlot = (MouseY() - 35) / 41
			invalidSlot# = (Float((MouseY() - 35) / 41) - Float(newSlot)) * 41
			If invalidSlot <= 36 Then
				If Not Empty(newSlot) Then
					If Slot <> newSlot Then
						PlaySound sndClick
					End If
					Slot = newSlot
					SlotSelected = True
				End If
			End If
		End If
		If MouseArea(365, 363, 240, 36)
			PlaySound sndClick
			CancelPressed = True
		End If
		If MouseArea(365, 404, 240, 36)
			If SlotSelected Then
				OKPressed = True
				PlaySound sndClick
			End If
		End If
	End If

	If key = 13 And SlotSelected Then
		PlaySound sndClick
		OKPressed = True
	End If
	
	FlushMouse()
	FlushKeys()

Until OKPressed Or CancelPressed

FreeImage imgPointer
FreeImage imgSaveLoad
FreeImage imgDisSL1
FreeImage imgDisSL2
FreeImage imgSlot
For Count = 0 To 9
	FreeImage imgShots(Count)
	Empty(Count) = False
	SlotName(Count) = ""
Next
FreeFont fntSaveLoad

If OKPressed Then
	StartPlay = True
End If

Return
End If