; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

count = 1
For shops.shop = Each shop
	If count = props\shop Then
		Exit
	End If
	count = count + 1
Next

imgShop = LoadImage("images\shop.jpg")
MaskImage imgShop, 255, 0, 255
imgDisableShop = LoadImage("images\disableshop.bmp")
MaskImage imgDisableShop, 255, 0, 255

FirstYI = 0
FirstNI = 0

overItmY = -1
overItmN = -1

YSelect = -1
NSelect = -1

FinishTalk = False

While Not FinishTalk

	WaitTimer frmRate
	
	Buy = True
	Sell = True

	RenderWorld
	
; CALCULATE BUYING/SELLING MODIFS
	If ME >= 150 Then
		VMY# = 1 + Float((Float(ME) / Float(250))) * 0.1
		VMN# = 1 - Float((Float(ME) / Float(250))) * 0.1
	Else
		VMY# = 1 - Float((Float(250) / Float(ME))) * 0.1
		VMN# = 1 + Float((Float(250) / Float(ME))) * 0.1
	End If
	
	DrawImage imgShop, 0, 330

	Color 255, 255, 255
	; WRITE BASE STUFF
	OutlineText(20, 340, "Stuff for sale (" + Shops\GOL + " golds):", False, False)
	OutlineText(260, 340, "Your stuff:", False, False)
	OutlineText(500, 340, "Golds: " + GOL, False, False)
	OutlineText(500, 360, "Potions: " + POT, False, False)
	OutlineText(500, 380, "Weapon: (" + (WTY + WME) + "d/" + Int((WTY + WME) * 150 * VMY) + "g)", False, False)
	OutlineText(510, 395, WEA, False, False)
	OutlineText(500, 415, "Armor: (" + AME + "a/" + Int(AME * 250 * VMY) + "g)", False, False)
	OutlineText(510, 430, ARM, False, False)
	
	; WRITE THE INVENTORIES
	TotalY = 0
	Count = 0
	For Items.Valuable = Each Valuable
		TotalY = TotalY + 1
		If Count = YSelect Then
			If Int(Int(items\value) * VMY) > Shops\GOL Then
				Sell = False
			End If
		End If
		If Count >= FirstYI And Count < FirstYI + 5
			Slct = False
			If Count = YSelect Then
				Slct = True
			End If
			If Slct Then
				Color 0, 0, 255
			Else
				Color 255, 255, 255
			End If
			If Count = overItmY And Slct Then
				Color 0, 255, 255
			ElseIf Count = overItmY Then
				Color 0, 255, 0
			End If
			OutlineText(265, 363 + (Count - FirstYI) * 15, getName(valuables(Items\ID)) + " (" + Int(Int(items\value) * VMY) + " golds)", False, False)
		End If
		Count = Count + 1
	Next
	
; DISPLAY POTIONS
	Color 255, 255, 255
	TotalN = 0
	DisplayN = 0
	If Shops\POT > 0 Then
		TotalN = TotalN + 1
		If FirstNI = 0 Then
			DisplayN = DisplayN + 1
			If NSelect = 0 Then
				If overItmN = 0 Then
					Color 0, 255, 255
				Else
					Color 0, 0, 255
				End If
			Else
				If overItmN = 0 Then
					Color 0, 255, 0
				Else
					Color 255, 255, 255
				End If
			End If
			OutlineText(25, 363, "Potion (" + Shops\POT + ", " + Int(35 * VMN) + " golds)", False, False)
		End If
	End If
	
; WEAPONS
	Count = 0
	While Count * 4 < Len(Shops\weapons)
		If DisplayN < 5 And TotalN >= FirstNI And TotalN <= FirstNI + 5
			Slct = False
			If TotalN = NSelect Then
				Slct = True
			End If
			If Slct Then
				Color 0, 0, 255
			Else
				Color 255, 255, 255
			End If
			If TotalN = overItmN And Slct Then
				Color 0, 255, 255
			ElseIf TotalN = overItmN Then
				Color 0, 255, 0
			End If
			NWTY = Int(Mid(Shops\weapons, 1 + Count * 4, 2))
			NWME = Int(Mid(Shops\weapons, 3 + Count * 4, 2))
			OutlineText(25, 363 + DisplayN * 15, getWEA(NWTY, NWME) + " (" + (NWTY + NWME) + "d/" + Int((NWTY + NWME) * 150 * VMN) + "g)", False, False)
			DisplayN = DisplayN + 1
		End If
		Count = Count + 1
		TotalN = TotalN + 1
	Wend

; ARMORS
	Count = 0
	While Count * 2 < Len(Shops\armors)
		If DisplayN < 5 And TotalN >= FirstNI And TotalN <= FirstNI + 5
			Slct = False
			If TotalN = NSelect Then
				Slct = True
			End If
			If Slct Then
				Color 0, 0, 255
			Else
				Color 255, 255, 255
			End If
			If TotalN = overItmN And Slct Then
				Color 0, 255, 255
			ElseIf TotalN = overItmN Then
				Color 0, 255, 0
			End If
			ShopAME = Int(Mid(Shops\armors, 1 + Count * 2, 2))
			OutlineText(25, 363 + DisplayN * 15, getARM(ShopAME) + " (" + ShopAME + "a/" + Int(ShopAME * 250 * VMN) + "g)", False, False)
			DisplayN = DisplayN + 1
		End If
		Count = Count + 1
		TotalN = TotalN + 1
	Wend

; VALUABLES
	Count = 0
	While Count * 6 < Len(Shops\items)
		If DisplayN < 5 And TotalN >= FirstNI And TotalN <= FirstNI + 5
			Slct = False
			If TotalN = NSelect Then
				Slct = True
			End If
			If Slct Then
				Color 0, 0, 255
			Else
				Color 255, 255, 255
			End If
			If TotalN = overItmN And Slct Then
				Color 0, 255, 255
			ElseIf TotalN = overItmN Then
				Color 0, 255, 0
			End If
			OutlineText(25, 363 + DisplayN * 15, getName(valuables(Mid(Shops\items, 1 + Count * 6, 3))) + " (" + Int(Int(Mid(Shops\items, 4 + Count * 6, 3)) * VMN) + " golds)", False, False)
			DisplayN = DisplayN + 1
		End If
		Count = Count + 1
		TotalN = TotalN + 1
	Wend

	If NSelect >= 0 Then
		Gosub getSelValue
		If SelValue > GOL Or (Abs(SelValue) > Shops\GOL And SelValue < 0) Then
			Buy = False
		End If
	End If
	
	If YSelect > TotalY - 1 Then
		YSelect = -1
	End If
	If NSelect > TotalN - 1 Then
		NSelect = -1
	End If
	
	If NSelect = -1 Then
		Buy = False
	End If
	If YSelect = -1 Then
		Sell = False
	End If
	
	If Not Buy Then
		DrawImage imgDisableShop, 20, 450
	End If
	
	If Not Sell Then
		DrawImage imgDisableShop, 260, 450
	End If
	
	; DRAW CURSOR
	DrawImage imgCursor, MouseX(), MouseY()
	
	Flip
	
	; PROCESS CLICKS
	
	overItmY = -1
	overItmN = -1
	button = GetMouse()
	If button = 1 Then
		If MouseArea(265, 363, 200, 74)
			ItmC = (MouseY() - 363) / 15 + FirstYI
			PlaySound sndClick
			If ItmC = YSelect Then
				YSelect = -1
			Else
				YSelect = ItmC
			End If 
		End If
		If MouseArea(25, 363, 200, 74)
			ItmC = (MouseY() - 363) / 15 + FirstNI
			PlaySound sndClick
			If ItmC = NSelect Then
				NSelect = -1
			Else
				NSelect = ItmC
			End If
		End If
		If MouseArea(475, 360, 15, 15)
			FirstYI = FirstYI - 1
			If FirstYI < 0 Then
				FirstYI = 0
				PlaySound sndInvalid
			Else
				PlaySound sndClick
			End If
		End If
		If MouseArea(475, 425, 15, 15)
			FirstYI = FirstYI + 1
			If FirstYI > TotalY - 5 Then
				FirstYI = TotalY - 5
				If FirstYI < 0 Then
					FirstYI = 0
				End If
				PlaySound sndInvalid
			Else
				PlaySound sndClick
			End If
		End If
		If MouseArea(235, 360, 15, 15)
			FirstNI = FirstNI - 1
			If FirstNI < 0 Then
				FirstNI = 0
				PlaySound sndInvalid
			Else
				PlaySound sndClick
			End If
		End If
		If MouseArea(235, 425, 15, 15)
			FirstNI = FirstNI + 1
			If FirstNI > TotalN - 5 Then
				FirstNI = TotalN - 5
				If FirstNI < 0 Then
					FirstNI = 0
				End If
				PlaySound sndInvalid
			Else
				PlaySound sndClick
			End If
		End If
; SELL
		If MouseArea(260, 450, 230, 20) And Sell
			PlaySound sndMoney
			Counter = 0
			For Items.Valuable = Each Valuable
				If Len(Items\ID) < 2 Then
					Items\ID = "0" + Items\ID
				End If
				If Len(Items\ID) < 3 Then
					Items\ID = "0" + Items\ID
				End If
				If Len(Items\Value) < 2 Then
					Items\Value = "0" + Items\Value
				End If
				If Len(Items\Value) < 3 Then
					Items\Value = "0" + Items\Value
				End If
				If Counter = YSelect Then
					MEU# = MEU# + Float(Int(Items\Value) * VMY) / 50
					If Len(Shops\Items) < 100 Then
						Shops\Items = Shops\Items + Items\ID + Items\Value
					End If
					Shops\GOL = Shops\GOL - Int(Items\Value) * VMY
					GOL = GOL + Int(Items\Value) * VMY
					AddLog("Sell Amount", Int(Items\Value) * VMY)
					AddLog("Sell Value", Int(Items\Value))
					MercRatio# = GetLog("Buy Amount") + GetLog("Sell Value")
					MercRatio = MercRatio / Float(GetLog("Buy Value") + GetLog("Sell Amount"))
					MercRatio = MercRatio * 100
					SetLog("Mercantile Efficiency", Int(MercRatio) + "%")
					TotalY = TotalY - 1
					Delete Items
				End If
				Counter = Counter + 1
			Next
; MAKE SURE IT IS WELL POSITIONED
			If FirstYI + 5 > TotalY Then
				FirstYI = TotalY - 5
			End If
			If FirstYI < 0 Then
				FirstYI = 0
			End If
			If YSelect > TotalY - 1 Then
				YSelect = TotalY - 1
			End If
		End If
; BUY
		If MouseArea(22, 450, 230, 20) And Buy
			PlaySound sndMoney
; BUY POTION
			TotalS = 0
			If Shops\POT > 0 Then
				TotalS = TotalS + 1
				If NSelect = 0 Then
					MEU# = MEU# + Float(selValue) / 50
					Shops\GOL = Shops\GOL + selValue
					GOL = GOL - selValue
					Shops\POT = Shops\POT - 1
					POT = POT + 1
					If Shops\POT = 0 Then
						NSelect = -1
					End If
					AddLog("Sell Amount", Int(selValue))
					AddLog("Sell Value", 35)
					MercRatio# = GetLog("Buy Amount") + GetLog("Sell Value")
					MercRatio = MercRatio / Float(GetLog("Buy Value") + GetLog("Sell Amount"))
					MercRatio = MercRatio * 100
					SetLog("Mercantile Efficiency", Int(MercRatio) + "%")
				End If
			End If
			Count = 0
; BUY WEAPON
			While Count * 4 < Len(shops\weapons) 	
				If TotalS = NSelect Then
					NWTY = Int(Mid(Shops\weapons, 1 + Count * 4, 2))
					NWME = Int(Mid(Shops\weapons, 3 + Count * 4, 2))
					MEU# = MEU# + Float(Abs(selValue)) / 50
					Shops\GOL = Shops\GOL + selValue
					GOL = GOL - selValue
					If count = 0 Then
						Part1$ = ""
					Else
						Part1$ = Mid(Shops\weapons, 1, Count * 4)
					End If
					Part2$ = Mid(Shops\Weapons, 1 + (Count + 1) * 4)
					If WTY < 10 Then
						NewWTY$ = "0" + WTY
					Else
						NewWTY$ = WTY
					End If
					If WME < 10 Then
						NewWME$ = "0" + WME
					Else
						NewWME$ = WME
					End If
					WTY = NWTY
					WME = NWME
					WEA = getWEA(WTY, WME)
					Shops\weapons = Part1 + Part2 + NewWTY + NewWME
				End If
				Count = Count + 1
				TotalS = TotalS + 1
			Wend
; BUY ARMOR
			Count = 0
			While Count * 2 < Len(shops\armors) 	
				If TotalS = NSelect Then
					ShopAME = Int(Mid(Shops\armors, 1 + Count * 2, 2))
					MEU# = MEU# + Float(Abs(selValue)) / 50
					Shops\GOL = Shops\GOL + selValue
					GOL = GOL - selValue
					If count = 0 Then
						Part1$ = ""
					Else
						Part1$ = Mid(Shops\armors, 1, Count * 2)
					End If
					Part2$ = Mid(Shops\armors, 1 + (Count + 1) * 2)
					If AME < 10 Then
						NewAME$ = "0" + AME
					Else
						NewAME$ = AME
					End If
					AME = ShopAME
					ARM = getARM(AME)
					Shops\armors = Part1 + Part2 + NewAME
				End If
				Count = Count + 1
				TotalS = TotalS + 1
			Wend
; BUY VALUABLE
			Count = 0
			While Count * 6 < Len(shops\items)
				If TotalS = NSelect Then
					If Count = 0 Then
						Part1$ = ""
					Else
						Part1$ = Mid(Shops\Items, 1, Count * 6)
					End If
					Part2$ = Mid(Shops\Items, 1 + (Count + 1) * 6)
					Items.Valuable = New Valuable
					Items\ID = Mid(Shops\Items, 1 + Count * 6, 3)
					Items\Value = Mid(Shops\Items, 4 + Count * 6, 3)
					Shops\GOL = Shops\GOL + Int(Items\Value) * VMN
					GOL = GOL - Int(Items\Value) * VMN
					MEU# = MEU# + Float(Abs(Int(Items\Value) * VMN)) / 50
					AddLog("Buy Amount", Int(Items\Value) * VMN)
					AddLog("Buy Value", Int(Items\Value))
					Shops\Items = Part1$ + Part2$
					MercRatio# = GetLog("Buy Amount") + GetLog("Sell Value")
					MercRatio = MercRatio / Float(GetLog("Buy Value") + GetLog("Sell Amount"))
					MercRatio = MercRatio * 100
					SetLog("Mercantile Efficiency", Int(MercRatio) + "%")
					TotalN = TotalN - 1
				End If
				Count = Count + 1
				TotalS = TotalS + 1
			Wend
; MAKE SURE IT IS WELL POSITIONED
			If FirstNI + 5 > TotalN Then
				FirstNI = TotalN - 5
			End If
			If FirstNI < 0 Then
				FirstNI = 0
			End If
			If NSelect > TotalN - 1 Then
				NSelect = TotalN - 1
			End If
		End If
	Else
		If MouseArea(265, 363, 200, 74)
			OverItmY = (MouseY() - 363) / 15 + FirstYI
		End If										
		If MouseArea(25, 363, 200, 74)
			OverItmN = (MouseY() - 363) / 15 + FirstNI
		End If										
	End If

	key = GetKey()
	If (MouseArea(500, 450, 120, 20) And button = 1) Or key = 27
		FinishTalk = True
		PlaySound sndClick
	End If
	
	FlushMouse
	
Wend

FreeImage imgShop
FreeImage imgDisableShop
FlushMouse
DAM = WTY + WME + ST / 5
AB = AME + RES / 5
Gosub ComputeWeight

If endedOK
.getSelValue
	TotalS = 0
	If Shops\POT > 0 Then
		If NSelect = 0 Then
			SelValue = 35 * VMN
		End If
		TotalS = TotalS + 1
	End If
	Count = 0
	While Count * 4 < Len(shops\weapons) 	
		If TotalS = NSelect Then
			NWTY = Int(Mid(Shops\weapons, 1 + Count * 4, 2))
			NWME = Int(Mid(Shops\weapons, 3 + Count * 4, 2))
			SelValue = (NWTY + NWME) * 150 * VMN - (WTY + WME) * 150 * VMY
		End If
		Count = Count + 1
		TotalS = TotalS + 1
	Wend
	Count = 0
	While Count * 2 < Len(shops\armors) 	
		If TotalS = NSelect Then
			ShopAME = Int(Mid(Shops\armors, 1 + Count * 2, 2))
			SelValue = ShopAME * 250 * VMN - AME * 250 * VMY
		End If
		Count = Count + 1
		TotalS = TotalS + 1
	Wend
	Count = 0
	While Count * 6 < Len(shops\items)
		If TotalS = NSelect Then
			SelValue = Int(Mid(Shops\items, 4 + Count * 6, 3)) * VMN
		End If
		Count = Count + 1
		TotalS = TotalS + 1
	Wend
Return
End If