; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

If WonTheGame Then
.Win
	CameraViewport camDefault, 0, 0, scrWidth, 1
	camWin = CreateCamera(NPCs\model)
	CameraProjMode camWin, 1
	CameraViewport camWin, 0, 1, scrWidth, scrHeight - 1
	MoveEntity camWin, 0, 8, -35
	PointEntity camWin, npcs\model
	CameraFogMode camWin, 1
	CameraClsColor camWin, 80, 15, 40
	CameraFogColor camWin, 80, 15, 40
	CameraFogRange camWin, 200, 500
	
	AnimateMD2 npcs\model, 3, 0.075, 178, 183
	
	frmRate2 = CreateTimer(15)
	
	While MD2Animating(npcs\model)
	
		MoveEntity camWin, 2, 0.7, 0
		PointEntity camWin, npcs\model
	
		WaitTimer(frmRate2)
		
		UpdateWorld
		RenderWorld
		
		Flip
	
	Wend
	
	y = 500
	Color 110, 60, 170
	
	While y > -600 And (Not KeyDown(1)) 
	
		WaitTimer frmRate2
		
		RenderWorld
		
		OutlineText(320, y, "'Arrrrrrrrrrgh! How could this be?!'", True, False)
		OutlineText(320, y+20, "'This CANNOT be!'", True, False)
		OutlineText(320, y+40, "says Chaos while fading away into the depths of hell...", True, False)
		OutlineText(320, y+80, "You have defeated him, he is now damned from this world,", True, False)
		OutlineText(320, y+100, "He will not be able to harm anyone...", True, False)
		OutlineText(320, y+140, "After he vanished, you found the treasures;", True, False)
		OutlineText(320, y+160, "10,000 gold pieces that are now all yours...", True, False)
		OutlineText(320, y+200, "Strange things happen however...", True, False)
		OutlineText(320, y+240, "Since you killed him, rumors have started to spread about you,", True, False)
		OutlineText(320, y+260, "People don't fear Chaos anymore, they now fear " + name + ",", True, False)
		OutlineText(320, y+280, "the famous, the strong, the terrible, the slaughterer... the daemon...", True, False)
		OutlineText(320, y+340, "You have overpowered Chaos.", True, False)
		OutlineText(320, y+370, "You have Chaos' riches.", True, False)
		OutlineText(320, y+400, "You have to live with it;", True, False)
		OutlineText(320, y+420, "People are now after your golds,", True, False)
		OutlineText(320, y+440, "They seek the fame of killing you...", True, False)
		OutlineText(320, y+500, "You are Chaos.", True, False)
		OutlineText(320, y+560, "The strong is the victim of his own glory", True, False)
	
		y = y - 1
		
		Flip
		
	Wend
	Gosub CloseTarget
	FreeEntity camWin
	FreeEntity NPCs\model
	Delete NPCs
	
	; GENERATE DAEMON HUNTERS
	Loading()
	
	groupCount = groupCount + 1
	groups.Group(groupCount) = New Group
	groupRace = 11
	groups(groupCount)\RaceID = groupRace
	alignType = Mid(groupRaces(groupRace), 3, 1)
	groups(groupCount)\ALI = Mid(groupRaces(groupRace), 4, 3)
	If Not alignType
		groups(groupCount)\ALI = groups(groupCount)\ALI * -1
	End If
	groups(groupCount)\ModelNumber = Mid(groupRaces(groupRace), 1, 2)
	groups(groupCount)\Stats = Mid(groupRaces(groupRace), 7, 4)
	InitialALI = groups(groupCount)\ALI
	groups(groupCount)\ALI = 1000
	groups(groupCount)\name = "Chaos Hunters"
	groups(groupCount)\Faction = -1000
	SetLog(groups(groupCount)\Name + " Group Faction", groups(groupCount)\Faction)
		
	For Counter = 1 To 500
		NPCs.NPC = New NPC
		Repeat
			NPCs\zx = WrapZone(zx - 20 + Rand(0, 40))
			NPCs\zy = WrapZone(zy - 20 + Rand(0, 40))
		Until NPCs\ZX <> zx And NPCS\zy <> zy
	
	
		NPCs\group = groupCount
		NPCs\lastFaction = groups(NPCs\group)\faction
	; SET THE MODEL
		Outer = Rand(1, 30)
		If Outer = 1 Then
			oldGroup = NPCs\group
			NPCs\group = Rand(0, groupCount)
		End If
		NPCs\race = Mid(groupRaces(groups(NPCs\group)\raceID), 11)
		NPCnum$ = groups(NPCs\group)\ModelNumber
		NPCs\number = NPCnum
		Count = 1
	; LOAD THE AVAILABLE TEXTURES AND SET ONE
		texTemp = LoadTexture("textures\pic_s01.jpg")
		Repeat
			FreeTexture texTemp
			Numb$ = Count
			If Count < 10 Then
				Numb = "0" + Numb
			End If
			texTemp = LoadTexture("models\npcs\npc" + NPCnum + "-" + numb + ".jpg")
			Count = Count + 1
		Until texTemp = 0
		MaxTex = Count - 2
		newTex = Rand(1, MaxTex)
		Texnum$ = newTex
		If newTex < 10 Then
			Texnum = "0" + Texnum
		End If
		NPCs\texnumber = texnum
		Repeat
			NPCs\X = Rand(60, 2500)
			NPCs\Y = Rand(60, 2500)
		Until (Not PropInWay(NPCs\X, NPCs\Y, 15 * NPCs\W, zx, zy))
	
	; SET NAME
		maxFirstNames = 0
		filName = ReadFile("data\" + NPCs\Race + "1.dat")
			While (Not Eof(filName))
				FirstNames(maxFirstNames) = ReadLine(filName)
				maxFirstNames = maxFirstNames + 1
			Wend
			maxFirstNames = maxFirstNames - 1
		CloseFile filName
		maxLastNames = 0
		filName = ReadFile("data\" + NPCs\Race + "2.dat")
			While (Not Eof(filName))
				LastNames(maxLastNames) = ReadLine(filName)
				maxLastNames = maxLastNames + 1
			Wend
			maxLastNames = maxLastNames - 1
		CloseFile filName
		firstName = Rand(0, maxFirstNames)
		NPCs\name = FirstNames(firstName) + " "
		secondName = Rand(1, 6)
		If secondName = 1 Then
			secondName = firstName
			While secondName = firstName
				secondName = Rand(0, maxFirstNames)
			Wend
			NPCs\name = NPCs\name + FirstNames(secondName) + " "
		End If
		NPCs\name = NPCs\name + LastNames(Rand(0, maxLastNames))		
		
	; STATS GENERATION
		StatsValue# = (HEAT + MOVT + MORT + ST + DE + ME + DAM + AB) * groups(NPCs\Group)\Stats * 1.5
		BStatsValue = StatsValue * Rnd(0.67, 0.73)
		RStatsValue = StatsValue * Rnd(0.28, 0.32)
		While BStatsValue > 0
			NPCs\HEA = NPCs\HEA + 10
			NPCs\MOV = NPCs\MOV + 10
			NPCs\MOR = NPCs\MOR + 10
			NPCs\ST = NPCs\ST + 5
			NPCs\DE = NPCs\DE + 5
			NPCs\ME = NPCs\ME + 5
			NPCs\DAM = NPCs\DAM + 3
			NPCs\AB = NPCs\AB + 1
			BStatsValue = BStatsValue - 50
		Wend
		While RStatsValue > 0
			StatChange = Rand(1, 6)
			Select StatChange
				Case 1
					NPCs\HEA = NPCs\HEA + 1
					RStatsValue = RStatsValue - 1
				Case 2
					NPCs\MOR = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 3
					NPCs\MOV = NPCs\MOR + 1
					RStatsValue = RStatsValue - 1
				Case 4
					NPCs\ST = NPCs\ST + 1
					RStatsValue = RStatsValue - 1
				Case 5
					NPCs\DE = NPCs\DE + 1
					RStatsValue = RStatsValue - 1
				Case 6
					NPCs\ME = NPCs\ME + 1
					RStatsValue = RStatsValue - 1
			End Select
		Wend
	
		NPCs\ALI = groups(NPCs\group)\ALI
		NPCs\GOL = Rand(15, 50) * groups(NPCs\Group)\Stats * groups(NPCs\Group)\Stats
		cd# = groups(NPCs\Group)\Stats
		NPCs\ALI = NPCs\ALI + Rand(0, 100) - 50
		NPCs\REA = CompREA(ALI, NPCs\ALI)
		NPCs\HEAT = NPCs\HEA
		NPCs\MOVT = NPCs\MOV
		NPCs\MORT = NPCs\MOR
	
	; SCALE FROM CONSIDER
		Consider1# = NPCs\ST + NPCs\DE + NPCs\ME + NPCs\DAM * 0.1 + NPCs\AB * 0.15
		Consider2# = ST + DE + ME + DAM * 0.1 + AB * 0.15
		Consi# = (Consider1 / Consider2) / CD
		NPCs\W = Consi + Rnd(0, 0.1) - 0.05
		NPCs\H = Consi + Rnd(0, 0.1) - 0.05
		
	; ITEMS GENERATION
		numItems = Rand(2, 8) * groups(NPCs\Group)\Stats
		NPCs\items = ""
		For count = 1 To numItems
			newItem$ = Rand(0, maxItems)
			If Len(newItem) < 2 Then
				newItem = "0" + newItem
			End If
			If Len(newItem) < 3 Then
				newItem = "0" + newItem
			End If
			itemValue$ = Rand(getLow(valuables(newItem)), getHigh(valuables(newItem)))
			If Len(itemValue) < 2 Then
				itemValue = "0" + itemValue
			End If
			If Len(itemValue) < 3 Then
				itemValue = "0" + itemValue
			End If
			NPCs\items = NPCs\items + newItem + itemValue
		Next		
		
	Next
	
	; FREE
	
	FreeTimer frmRate2
	CameraViewport camDefault, 0, 0, scrWidth, 330
Return
End If