; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; LOAD MODULE PART 2

If LoadingLoad2 Then
.Load2

If StartPlay Then
	QuickSave = Slot
	loadFile = Slot
	filSlot = ReadFile("saves\slot" + loadFile + "\character.dat")
		gamename$ = ReadLine(filSlot)
		name$ = ReadLine(filSlot)
		version$ = ReadLine(filSlot)
		If NotCompatible(version, VersionNumber$)
			startPlay = False
			RuntimeError = "Invalid Version: " + versionNumber + " != " + version
		Else
			logPath$ = "saves\slot" + loadFile + "\"
			age$ = ReadLine(filSlot)
			birthDay = ReadInt(filSlot)
			minute# = ReadFloat(filSlot)
			hour = ReadInt(filSlot)
			day = ReadInt(filSlot)
			year = ReadInt(filSlot)
			ZX = ReadInt(filSlot)
			ZY = ReadInt(filSlot)
			EntryPosX = ReadInt(filSlot)
			EntryPosY = ReadInt(filSlot)
			EntryAngle = ReadInt(filSlot)
			POW = ReadInt(filSlot)
			RES = ReadInt(filSlot)
			COO = ReadInt(filSlot)
			SPE = ReadInt(filSlot)
			MIN = ReadInt(filSlot)
			AWA = ReadInt(filSlot)
			MOV = ReadInt(filSlot)
			MOVT = ReadInt(filSlot)
			MOR = ReadInt(filSlot)
			MORT = ReadInt(filSlot)
			HEA = ReadInt(filSlot)
			HEAT = ReadInt(filSlot)
			CAR = ReadInt(filSlot)
			CART = ReadInt(filSlot)
			ST = ReadInt(filSlot)
			STU# = ReadFloat(filSlot)
			STUS = ReadInt(filSlot)
			STRA = ReadInt(filSlot)
			DE = ReadInt(filSlot)
			DEU# = ReadFloat(filSlot)
			DEUS = ReadInt(filSlot)
			DERA = ReadInt(filSlot)
			ME = ReadInt(filSlot)
			MEU# = ReadFloat(filSlot)
			MEUS = ReadInt(filSlot)
			MERA = ReadInt(filSlot)
			GOL = ReadInt(filSlot)
			POT = ReadInt(filSlot)
			WEA$ = ReadLine(filSlot)
			ARM$ = ReadLine(filSlot)
			WTY = ReadInt(filSlot)
			WME = ReadInt(filSlot)
			AME = ReadInt(filSlot)
			ALI = ReadInt(filSlot)
			DAM = ReadInt(filSlot)
			AB = ReadInt(filSlot)
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\groups.dat")
			groupCount = ReadInt(filSlot)
			For count = 0 To groupCount
				groups.Group(count) = New Group
				groups(count)\name$ = ReadLine(filSlot)
				groups(count)\raceid = ReadInt(filSlot)
				groups(count)\ALI = ReadInt(filSlot)
				groups(count)\Faction = ReadInt(filSlot)
				groups(count)\modelnumber$ = ReadLine(filSlot)
				groups(count)\stats# = ReadFloat(filSlot)
			Next 
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\zones.dat")
			While Not(Eof(filSlot))
				x = ReadInt(filSlot)
				y = ReadInt(filSlot)
				zones.Zone(x, y) = New Zone
				zones(x, y)\exit1$ = ReadLine(filSlot)
				zones(x, y)\exit2$ = ReadLine(filSlot)
				zones(x, y)\exit3$ = ReadLine(filSlot)
				zones(x, y)\exit4$ = ReadLine(filSlot)
				zones(x, y)\exit5$ = ReadLine(filSlot)
				zones(x, y)\terrain = ReadInt(filSlot)
				zones(x, y)\texture = ReadInt(filSlot)
			Wend
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\npcs.dat")
			While Not(Eof(filSlot))
				NPCs.NPC = New NPC
				NPCs\Number$ = ReadLine(filSlot)
				NPCs\TexNumber$ = ReadLine(filSlot)
				NPCs\X = ReadInt(filSlot)
				NPCs\Y = ReadInt(filSlot)
				NPCs\ZX = ReadInt(filSlot)
				NPCs\ZY = ReadInt(filSlot)
				NPCs\H# = ReadFloat(filSlot)
				NPCs\W# = ReadFloat(filSlot)
				NPCs\name$ = ReadLine(filSlot)
				NPCs\race$ = ReadLine(filSlot)
				NPCs\group = ReadInt(filSlot)
				NPCs\lastfaction = ReadInt(filSlot)
				NPCs\HEA = ReadInt(filSlot)
				NPCs\HEAT = ReadInt(filSlot)
				NPCs\MOV = ReadInt(filSlot)
				NPCs\MOVT = ReadInt(filSlot)
				NPCs\MOR = ReadInt(filSlot)
				NPCs\MORT = ReadInt(filSlot)
				NPCs\ST = ReadInt(filSlot)
				NPCs\DE = ReadInt(filSlot)
				NPCs\ME = ReadInt(filSlot)
				NPCs\DAM = ReadInt(filSlot)
				NPCs\AB = ReadInt(filSlot)
				NPCs\ALI = ReadInt(filSlot)
				NPCs\REA = ReadInt(filSlot)
				NPCs\GOL = ReadInt(filSlot)
				NPCs\Items = ReadLine(filSlot)
			Wend
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\props.dat")
			While Not(Eof(filSlot))
				props.Prop = New Prop
				Props\ModelPath$ = ReadLine(filSlot)
				Props\TexPath$ = ReadLine(filSlot)
				Props\X = ReadInt(filSlot)
				Props\Y = ReadInt(filSlot)
				Props\H = ReadInt(filSlot)
				Props\Angle = ReadInt(filSlot)
				Props\WS# = ReadFloat(filSlot)
				Props\HS# = ReadFloat(filSlot)
				Props\Pitch = ReadInt(filSlot)
				Props\Radius = ReadInt(filSlot)
				Props\ZX = ReadInt(filSlot)
				Props\ZY = ReadInt(filSlot)
				Props\Treasure = ReadInt(filSlot)
				Props\GOL = ReadInt(filSlot)
				Props\Shop = ReadInt(filSlot)
				If Not isOlder(version$, "0.3.1 Beta") Then
					Props\Quest = ReadInt(filSlot)
				End If
			Wend
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\items.dat")
			While Not(Eof(filSlot))
			    items.Valuable = New Valuable
				items\id = ReadLine(filSlot)
				items\value = ReadLine(filSlot)
			Wend
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\log.dat")
			While Not(Eof(filSlot))
			    logs.LogData = New LogData
				logs\name = ReadLine(filSlot)
				logs\value = ReadLine(filSlot)
			Wend
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\shops.dat")
			While Not(Eof(filSlot))
			    shops.Shop = New Shop
				shops\gol = ReadInt(filSlot)
				shops\pot = ReadInt(filSlot)
				shops\items$ = ReadLine(filSlot)
				shops\armors$ = ReadLine(filSlot)
				shops\weapons$ = ReadLine(filSlot)
			Wend
		End If
		CloseFile filSlot
		filSlot = ReadFile("saves\slot" + loadFile + "\quests.dat")
			If filSlot > 0 Then
				While Not(Eof(filSlot)) 
					Quests.Quest = New Quest
					Quests\ID = ReadInt(filSlot)
					Quests\Typ = ReadInt(filSlot)
					Quests\Name$ = ReadLine(filSlot)
					Quests\Done = ReadInt(filSlot)
				Wend
				CloseFile filSlot
			End If
End If

Return
End If