; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

AmbientLight 255, 255, 255
camDefault = CreateCamera()
CameraProjMode camDefault, 1
MoveEntity camDefault, -13, 7, 27
TurnEntity camDefault, 0, 180, 0
If Rand(1, 5) = 1 Then
	model$ = Rand(1, maxRaces + 1)
	If Int(model$) < 10 Then
		model$ = "0" + model$
	End If
Else
	model$ = "01"
End If
mdlGoblin = LoadMD2("models\npcs\npc" + model$ + ".md2")
EntityTexture mdlGoblin, LoadTexture("models\npcs\npc" + model$ + "-01.jpg")
imgMenu = LoadImage("images\menu.bmp")
MaskImage imgMenu, 255, 0, 255
imgCursor = LoadImage("images\cursor.bmp")
MaskImage imgCursor, 255, 0, 255
newanim = MilliSecs()
sndGoboDie = LoadSound("sounds\die" + model$ + ".wav")
done = 0
play = 0
fntDefault = LoadFont("Times New Roman", 12)
SetFont fntDefault
While Not done
	
	WaitTimer(frmRate)

	If newanim < MilliSecs() - 5000 And (Not MD2Animating(mdlGoblin))
  		SeedRnd MilliSecs()
		anim = Rand(1,2)
		Select anim
			Case 1
				AnimateMD2 mdlGoblin, 3, 0.12, 72, 84
		    Case 2
			    AnimateMD2 mdlGoblin, 3, 0.12, 95, 112
		End Select
		newanim = MilliSecs()
	End If
	If Not MD2Animating(mdlGoblin)
		AnimateMD2 mdlGoblin, 3, 0.12, 0, 39
	End If

	If MouseDown(1)
		If MouseArea(400, 254, 90, 33) Or MouseArea(400, 299, 97, 33)
			PlaySound sndClick
			AnimateMD2 mdlGoblin, 3, 0.12, 84, 95
			done = 1
			play = 1
		End If
		If MouseArea(400, 299, 97, 33)
			PlaySound sndClick
			load = True
		End If
		If MouseArea(400, 344, 86, 33)
			PlaySound sndClick
			PlaySound sndGoboDie
			AnimateMD2 mdlGoblin, 3, 0.12, 190, 196
			done = 1
		End If
	End If

	UpdateWorld
	RenderWorld

	DrawImage imgMenu, 0, 0
	DrawImage imgCursor, MouseX(), MouseY()
	Color 255, 255, 255
	OutlineText(580, 470, "v" + versionNumber, True, True)
 
	Flip
	
Wend

While MD2Animating(mdlGoblin)

	WaitTimer(frmRate)

	UpdateWorld
	RenderWorld
	
	DrawImage imgMenu, 0, 0
	Color 255, 255, 255
	OutlineText(580, 470, "v" + versionNumber, True, True)
	
	Flip

Wend

If Not play
	End
End If

FreeEntity camDefault
camDefault = 0
FreeEntity mdlGoblin
FreeImage imgMenu
FreeImage imgCursor
FreeSound sndGoboDie