; This source code is copyrighted (c) to Jocelyn Perreault.
; It may not be used to create another game. You can modify
; it (i.e., make mods) but you need to notify me if you do
; so, and my name must remain in the credits. It cannot be
; redistributed (the source code and the game itself).
; Thanks,
;                 Jocelyn "GoSsE Korupted" Perreault
;                  gosse@nuloen.com
;                  Nuclear Loaded Entertainment
;                  http://www.nuloen.com/

; SAVE MODULE

imgPointer = LoadImage("images\cursor.bmp")
imgSaveLoad = LoadImage("images\saveload.jpg")
imgDisSL1 = LoadImage("images\disableSL1.bmp")
imgDisSL2 = LoadImage("images\disableSL1.bmp")
imgSlot = LoadImage("images\slot.bmp")
MaskImage imgPointer, 255, 0, 255
MaskImage imgSaveLoad, 255, 0, 255
MaskImage imgDisSL1, 255, 0, 255
MaskImage imgDisSL2, 255, 0, 255
MaskImage imgSlot, 255, 0, 255
fntSaveLoad = LoadFont("Times New Roman", 14, True)
SetFont fntSaveLoad

Slot = 0
OKPressed = False
CancelPressed = False

For Count = 0 To 9
	imgShots(Count) = LoadImage("saves\slot" + Count + "\screenshot.bmp")
	MaskImage imgShots(Count), 255, 0, 255
	filSlot = ReadFile("saves\slot" + Count + "\character.dat")
		SlotName(Count) = ReadLine(filSlot)
		If Count = 0 Then
			ModifiedName$ = SlotName(Count)
			If Left(ModifiedName, 1) = "*" Then
				ModifiedName = ""
			End If
		End If
		If Left(SlotName(Count), 1) = "*" Then
			Empty(Count) = True
			SlotName(Count) = Mid(SlotName(Count), 2)
		Else
			Info(Count, 0) = ReadLine(filSlot)
			VNs(Count) = ReadLine(filSlot)
			TempData$ = ReadLine(filSlot)
			TempData$ = ReadInt(filSlot)
			TDminute# = ReadFloat(filSlot)
			TDhour = ReadInt(filSlot)
			TDday = ReadInt(filSlot)
			TDyear = ReadInt(filSlot)
			minu$ = Int(TDminute)
			If Int(minu) < 10 Then
				minu = "0" + minu
			End If
			If minu = "60" Then
				minu = "00"
			End If
			hr$ = Int(TDhour)
			If hr = "24" Then
				hr = "0"
			End If
			dayS$ = Int(TDday)
			If dayS = "366" Then
				dayS = "1"
			End If
			Info(Count, 1) = hr+":"+minu+" on day "+dayS+" of the year "+TDyear
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 2) = "POW: " + ReadInt(filSlot)
			Info(Count, 8) = "RES: " + ReadInt(filSlot)
			Info(Count, 3) = "COO: " + ReadInt(filSlot)
			Info(Count, 9) = "SPE: " + ReadInt(filSlot)
			Info(Count, 4) = "MIN: " + ReadInt(filSlot)
			Info(Count, 10) = "AWA: " + ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 5) = "Strength: " + ReadInt(filSlot)
			TempData = ReadFloat(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 6) = "Dexterity: " + ReadInt(filSlot)
			TempData = ReadFloat(filSlot)
			TempData = ReadInt(filSlot)
			TempData = ReadInt(filSlot)
			Info(Count, 7) = "Mental: " + ReadInt(filSlot)
		End If
	CloseFile filSlot
Next

Repeat

	WaitTimer frmRate
	
	DrawImage imgSaveLoad, 0, 0

	DrawImage imgShots(Slot), 365, 35
	
	Color 255, 255, 255
	For Count = 0 To 9
		If Count = Slot Then
			Color 85, 85, 85
			OutlineText(45, 53 + 41 * Count, ModifiedName + "|", False, True)
			Color 255, 255, 255
		Else
			OutlineText(45, 53 + 41 * Count, SlotName(Count), False, True)
		End If
	Next
	
	DrawImage imgSlot, 10, 35 + 41 * Slot
	If Not Empty(Slot)
		For Count = 0 To 7
			OutlineText(375, 230 + Count * 15, Info(Slot, Count), False, False)
		Next
		For Count = 8 To 10
			OutlineText(475, 230 + (Count - 6) * 15, Info(Slot, Count), False, False)
		Next
		If NotCompatible(VNs(Slot), VersionNumber$) Then
			Color 255, 0, 0
		End If
		OutlineText(475, 335, "v" + VNs(Slot), False, False)
	End If
	
	DrawImage imgPointer, MouseX(), MouseY()
	
	Flip
	
	key = GetKey()
	
	If (key >= 65 And key <= 90) Or (key >= 97 And key <= 122) Or key = 32 Or key = 39
		ModifiedName = ModifiedName + Chr$(key)
		PlaySound sndClick
	ElseIf key = 8
		If Len(ModifiedName) > 0 
			ModifiedName = Left(ModifiedName, Len(ModifiedName) - 1)
			PlaySound sndClick
		Else
			PlaySound sndInvalid
		End If
	End If
	
	button = GetMouse()
	
	If button = 1 Then
		If MouseArea(35, 35, 295, 409)
			newSlot = (MouseY() - 35) / 41
			invalidSlot# = (Float((MouseY() - 35) / 41) - Float(newSlot)) * 41
			If invalidSlot <= 36 Then
				If Slot <> newSlot Then
					PlaySound sndClick
				End If
				Slot = newSlot
				If Empty(Slot)
					ModifiedName = ""
				Else
					ModifiedName = SlotName(Slot)
				End If
			End If
		End If
		If MouseArea(365, 363, 240, 36)
			PlaySound sndClick
			CancelPressed = True
		End If
		If MouseArea(365, 404, 240, 36)
			PlaySound sndClick
			OKPressed = True
		End If
	End If
	
	If key = 13 Then
		PlaySound sndClick
		OKPressed = True
	End If
	
	FlushMouse
	FlushKeys

Until OKPressed Or CancelPressed

FreeImage imgPointer
FreeImage imgSaveLoad
FreeImage imgDisSL1
FreeImage imgDisSL2
FreeImage imgSlot
For Count = 0 To 9
	FreeImage imgShots(Count)
	Empty(Count) = False
	SlotName(Count) = ""
Next
FreeFont fntSaveLoad

If OKPressed Then
	gamename = modifiedname
	Gosub QuickSave
End If

If notloadingit
.QuickSave
	QuickSave = Slot
	loadFile = Slot
	logPath$ = "saves\slot" + loadFile + "\"
	SaveImage(imgSS, "saves\slot" + loadFile + "\screenshot.bmp")
	filSlot = WriteFile("saves\slot" + loadFile + "\character.dat")
		WriteLine filSlot, gamename
		WriteLine filSlot, name
		WriteLine filSlot, versionNumber
		WriteLine filSlot, age
		WriteInt filSlot, birthDay
		WriteFloat filSlot, minute
		WriteInt filSlot, hour
		WriteInt filSlot, day
		WriteInt filSlot, year
		WriteInt filSlot, ZX
		WriteInt filSlot, ZY
		WriteInt filSlot, Int(EntityX(mdlKnight))
		WriteInt filSlot, Int(EntityZ(mdlKnight))
		WriteInt filSlot, Int(EntityYaw(mdlKnight))
		WriteInt filSlot, POW
		WriteInt filSlot, RES
		WriteInt filSlot, COO
		WriteInt filSlot, SPE
		WriteInt filSlot, MIN
		WriteInt filSlot, AWA
		WriteInt filSlot, MOV
		WriteInt filSlot, MOVT
		WriteInt filSlot, MOR
		WriteInt filSlot, MORT
		WriteInt filSlot, HEA
		WriteInt filSlot, HEAT
		WriteInt filSlot, CAR
		WriteInt filSlot, CART
		WriteInt filSlot, ST
		WriteFloat filSlot, STU#
		WriteInt filSlot, STUS
		WriteInt filSlot, STRA
		WriteInt filSlot, DE
		WriteFloat filSlot, DEU#
		WriteInt filSlot, DEUS
		WriteInt filSlot, DERA
		WriteInt filSlot, ME
		WriteFloat filSlot, MEU#
		WriteInt filSlot, MEUS
		WriteInt filSlot, MERA
		WriteInt filSlot, GOL
		WriteInt filSlot, POT
		WriteLine filSlot, WEA
		WriteLine filSlot, ARM
		WriteInt filSlot, WTY
		WriteInt filSlot, WME
		WriteInt filSlot, AME
		WriteInt filSlot, ALI
		WriteInt filSlot, DAM
		WriteInt filSlot, AB
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\groups.dat")
		WriteInt filSlot, groupCount
		For count = 0 To groupCount
			WriteLine filSlot, groups(count)\name
			WriteInt filSlot, groups(count)\raceid
			WriteInt filSlot, groups(count)\ALI
			WriteInt filSlot, groups(count)\Faction
			WriteLine filSlot, groups(count)\modelnumber
			WriteFloat filSlot, groups(count)\stats
		Next 
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\zones.dat")
		For x = 0 To 99
			For y = 0 To 99
				If zones(x,y) <> Null Then
					WriteInt filSlot, x
					WriteInt filSlot, y
					WriteLine filSlot, zones(x, y)\exit1
					WriteLine filSlot, zones(x, y)\exit2
					WriteLine filSlot, zones(x, y)\exit3
					WriteLine filSlot, zones(x, y)\exit4
					WriteLine filSlot, zones(x, y)\exit5
					WriteInt filSlot, zones(x, y)\terrain
					WriteInt filSlot, zones(x, y)\texture
				End If
			Next
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\npcs.dat")
		For NPCs.NPC = Each NPC
			WriteLine filSlot, NPCs\Number
			WriteLine filSlot, NPCs\TexNumber
			If NPCs\ZX = ZX And NPCs\ZY = ZY Then
				WriteInt filSlot, Int(EntityX(NPCs\model))
				WriteInt filSlot, Int(EntityZ(NPCs\model))
			Else
				WriteInt filSlot, NPCs\X
				WriteInt filSlot, NPCs\Y
			End If
			WriteInt filSlot, NPCs\ZX
			WriteInt filSlot, NPCs\ZY
			WriteFloat filSlot, NPCs\H
			WriteFloat filSlot, NPCs\W
			WriteLine filSlot, NPCs\name
			WriteLine filSlot, NPCs\race
			WriteInt filSlot, NPCs\group
			WriteInt filSlot, NPCs\lastfaction
			WriteInt filSlot, NPCs\HEA
			WriteInt filSlot, NPCs\HEAT
			WriteInt filSlot, NPCs\MOV
			WriteInt filSlot, NPCs\MOVT
			WriteInt filSlot, NPCs\MOR
			WriteInt filSlot, NPCs\MORT
			WriteInt filSlot, NPCs\ST
			WriteInt filSlot, NPCs\DE
			WriteInt filSlot, NPCs\ME
			WriteInt filSlot, NPCs\DAM
			WriteInt filSlot, NPCs\AB
			WriteInt filSlot, NPCs\ALI
			WriteInt filSlot, NPCs\REA
			WriteInt filSlot, NPCs\GOL
			WriteLine filSlot, NPCs\Items
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\props.dat")
		For props.Prop = Each Prop
			WriteLine filSlot, Props\ModelPath
			WriteLine filSlot, Props\TexPath
			WriteInt filSlot, Props\X
			WriteInt filSlot, Props\Y
			WriteInt filSlot, Props\H
			WriteInt filSlot, Props\Angle
			WriteFloat filSlot, Props\WS
			WriteFloat filSlot, Props\HS
			WriteInt filSlot, Props\Pitch
			WriteInt filSlot, Props\Radius
			WriteInt filSlot, Props\ZX
			WriteInt filSlot, Props\ZY
			WriteInt filSlot, props\Treasure
			WriteInt filSlot, props\GOL
			WriteInt filSlot, props\Shop
			WriteInt filSlot, props\Quest
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\items.dat")
		For items.Valuable = Each Valuable
			WriteLine filSlot, items\id
			WriteLine filSlot, items\value
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\log.dat")
		For logs.LogData = Each logData
			WriteLine filSlot, logs\name
			WriteLine filSlot, logs\value
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\shops.dat")
		For shops.Shop = Each Shop
			WriteInt filSlot, shops\gol
			WriteInt filSlot, shops\pot
			WriteLine filSlot, shops\items
			WriteLine filSlot, shops\armors
			WriteLine filSlot, shops\weapons
		Next
	CloseFile filSlot
	filSlot = WriteFile("saves\slot" + loadFile + "\quests.dat")
		For Quests.Quest = Each Quest
			WriteInt filSlot, Quests\ID
			WriteInt filSlot, Quests\Typ
			WriteLine filSlot, Quests\Name$
			WriteInt filSlot, Quests\Done
		Next
	CloseFile filSlot
	Return
End If